/**********************************************************************
 *
 * $Id: more_info_button_clicked.c,v 1.3 2000/05/04 01:17:02 htran Exp $
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 **********************************************************************/
#include "signal_callbacks.h"

extern GtkWidget *more_info;

static void
dismiss_button_clicked(GtkWidget *w,gpointer data){
  gtk_widget_set_sensitive(GTK_WIDGET(more_info),TRUE);
  gtk_widget_destroy(data);
}

void more_info_button_clicked(GtkWidget *w, gpointer data){
  GtkWidget *dialog, *textbox, *okay_button;
  GtkWidget *vscrollbar, *hbox;


  dialog = gtk_dialog_new();
  gtk_window_set_title(GTK_WINDOW(dialog),"More Information");
  gtk_window_set_default_size(GTK_WINDOW(dialog),400,100);
  
  okay_button = gtk_button_new_with_label("Dismiss");
  /* Ensure that the dialog box is destroyed when the user clicks ok. */
  gtk_signal_connect(GTK_OBJECT (okay_button), "clicked",
							GTK_SIGNAL_FUNC (dismiss_button_clicked), 
							dialog);

  gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->action_area),
                     okay_button);
  
  textbox=gtk_text_new(NULL,NULL);
  gtk_text_set_editable(GTK_TEXT(textbox),FALSE);
  gtk_text_set_word_wrap(GTK_TEXT(textbox),TRUE);
  
  /* horizontal box for text box and scroll bar */
  hbox=gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),hbox,TRUE,TRUE,0);
  textbox=gtk_text_new(NULL,NULL);
  gtk_text_set_editable(GTK_TEXT(textbox),FALSE);
  gtk_text_set_word_wrap(GTK_TEXT(textbox),TRUE);
  gtk_box_pack_start(GTK_BOX(hbox),textbox,TRUE,TRUE,0);
  vscrollbar=gtk_vscrollbar_new (GTK_TEXT(textbox)->vadj);
  
  gtk_box_pack_start(GTK_BOX(hbox), vscrollbar, FALSE, FALSE, 0);
  gtk_text_insert(GTK_TEXT(textbox),NULL,NULL,
                  NULL,data,-1);
  gtk_widget_show (vscrollbar);
  
  gtk_widget_set_sensitive(GTK_WIDGET(more_info),FALSE);
  
  gtk_widget_show_all(dialog);
}





