/**********************************************************************
 *
 * $Id: xmim.c,v 1.2 2000/05/03 19:25:29 htran Exp $
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 **********************************************************************/


#include <gtk/gtk.h>
#include <pthread.h>
#include "lists.h"
#include "read_cache.h"
#include "sdp_listener.h"
#include "signal_callbacks.h"
#include "../mim/arguments.h"
#include "../mim/listeners.h"


node *mpegListHead=NULL, *mpegListTail=NULL;
node *otherListHead=NULL, *otherListTail=NULL;

GtkWidget *mpegVideoCLIST;
GtkWidget *otherVideoCLIST;

pthread_mutex_t argumentsLock;
pthread_mutex_t guiLock;
pthread_mutex_t playingLock;
pthread_t videoThread;
pthread_t audioThread;

args_t arguments;

int main(int argc, char *argv[]){
  
  GtkWidget *mainWINDOW;
  GtkWidget *allVBOX, *commandHBOX, *anonymousHBOX;
  GtkWidget *mpegLABEL, *otherLABEL;
  GtkWidget *quitBUTTON, *helpBUTTON, *anonymousBUTTON;
  GtkWidget *notebook;
  GtkWidget *mpegSCROLLEDWINDOW,*otherSCROLLEDWINDOW;
  GtkWidget *mpegVideoVBOX, *otherVideoVBOX;
  
  pthread_t sdpListenerThread;  
  
  char *column_titles[]={"Session Names"};
  
  g_thread_init(NULL);
  
  gtk_init(&argc, &argv);
  
  pthread_mutex_init(&argumentsLock,NULL);
  pthread_mutex_init(&guiLock,NULL);
  pthread_mutex_init(&playingLock,NULL);
  
  /************************************************************
	* start main window
	************************************************************/
  mainWINDOW=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize(mainWINDOW,400,500);
  gtk_window_set_policy(GTK_WINDOW(mainWINDOW),TRUE,TRUE,FALSE);
  gtk_signal_connect(GTK_OBJECT(mainWINDOW),"destroy",
							GTK_SIGNAL_FUNC(gtk_main_quit),NULL);
  gtk_window_set_title(GTK_WINDOW(mainWINDOW),"Mim isn't mtv(p)");
  
  
  allVBOX=gtk_vbox_new(FALSE,0);  
  gtk_container_set_border_width(GTK_CONTAINER(allVBOX),0);
  gtk_container_add(GTK_CONTAINER(mainWINDOW), allVBOX);
  gtk_widget_show(allVBOX);
  
  
  commandHBOX=gtk_hbox_new(TRUE,0);
  gtk_box_pack_start(GTK_BOX(allVBOX),commandHBOX,FALSE,FALSE,0);
  gtk_widget_show(commandHBOX);
  
  /* the help and quit buttons */
  helpBUTTON=gtk_button_new_with_label("Help");
  gtk_box_pack_start(GTK_BOX(commandHBOX),helpBUTTON,TRUE,TRUE,0);
  gtk_signal_connect(GTK_OBJECT(helpBUTTON),"clicked",
							GTK_SIGNAL_FUNC(help_button_clicked),NULL); 
  gtk_widget_show(helpBUTTON);
  
  quitBUTTON=gtk_button_new_with_label("Quit");
  gtk_box_pack_start(GTK_BOX(commandHBOX),quitBUTTON,TRUE,TRUE,0);
  gtk_signal_connect(GTK_OBJECT(quitBUTTON),"clicked",
							GTK_SIGNAL_FUNC(quit_button_clicked),NULL); 
  gtk_widget_show(quitBUTTON);
    
  /************************************************************
	* Notebook has problem with resizing
	*
	************************************************************/
  
  /************************************************************
	*Notebook 
	************************************************************/
  
  notebook=gtk_notebook_new();
  gtk_box_pack_start(GTK_BOX(allVBOX),notebook,TRUE,TRUE,0);
  
  
  /* mpeg */
  mpegLABEL=gtk_label_new("MPEG Session Listings");
  gtk_widget_show(mpegLABEL);
  
  mpegVideoVBOX=gtk_vbox_new(FALSE,0);
  gtk_widget_show(mpegVideoVBOX);
  
  /* make scrolledwindows and clist for mpeg */
  mpegSCROLLEDWINDOW=gtk_scrolled_window_new(NULL,NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(mpegSCROLLEDWINDOW),
											GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);
  gtk_widget_show(mpegSCROLLEDWINDOW);
  gtk_box_pack_start(GTK_BOX(mpegVideoVBOX),mpegSCROLLEDWINDOW,TRUE,TRUE,0);
  
  /* clist */
  mpegVideoCLIST=gtk_clist_new_with_titles(1,column_titles);
  gtk_clist_column_titles_hide(GTK_CLIST(mpegVideoCLIST));
  gtk_clist_set_column_width(GTK_CLIST(mpegVideoCLIST), 
									  1,80);
  gtk_clist_set_sort_type(GTK_CLIST(mpegVideoCLIST),GTK_SORT_ASCENDING);
  gtk_clist_set_shadow_type(GTK_CLIST(mpegVideoCLIST),GTK_SHADOW_OUT);
  gtk_clist_set_selection_mode(GTK_CLIST(mpegVideoCLIST),
										 GTK_SELECTION_SINGLE);
  gtk_clist_set_auto_sort(GTK_CLIST(mpegVideoCLIST),TRUE);
  gtk_clist_set_reorderable(GTK_CLIST(mpegVideoCLIST),TRUE); 
  gtk_signal_connect(GTK_OBJECT(mpegVideoCLIST),"select_row",
                     GTK_SIGNAL_FUNC(selection_made_mpeg_list),
                     &mpegListHead); 
  
  gtk_container_add(GTK_CONTAINER(mpegSCROLLEDWINDOW),mpegVideoCLIST);
  gtk_widget_show(mpegVideoCLIST);

  /* append to notebook */
  gtk_notebook_append_page(GTK_NOTEBOOK(notebook),mpegVideoVBOX,
			   mpegLABEL);
    
  /* other video */
  otherLABEL=gtk_label_new("Other Session Listings");
  gtk_widget_show(otherLABEL);

  otherVideoVBOX=gtk_vbox_new(FALSE,0);
  gtk_widget_show(otherVideoVBOX);
  
  /* make scrolledwindows and clist for other */
  otherSCROLLEDWINDOW=gtk_scrolled_window_new(NULL,NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(otherSCROLLEDWINDOW),
											GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);
  gtk_widget_show(otherSCROLLEDWINDOW);
  gtk_box_pack_start(GTK_BOX(otherVideoVBOX),otherSCROLLEDWINDOW,TRUE,TRUE,0);
  
  /* other clist */
  otherVideoCLIST=gtk_clist_new_with_titles(1,column_titles);
  gtk_clist_column_titles_hide(GTK_CLIST(otherVideoCLIST));
  gtk_clist_set_column_width(GTK_CLIST(otherVideoCLIST), 
									  1,80);
  gtk_clist_set_sort_type(GTK_CLIST(otherVideoCLIST),GTK_SORT_ASCENDING);
  gtk_clist_set_shadow_type(GTK_CLIST(otherVideoCLIST),GTK_SHADOW_OUT);
  gtk_clist_set_selection_mode(GTK_CLIST(otherVideoCLIST),
										 GTK_SELECTION_SINGLE);
  gtk_clist_set_auto_sort(GTK_CLIST(otherVideoCLIST),TRUE);
  gtk_clist_set_reorderable(GTK_CLIST(otherVideoCLIST),TRUE); 
  gtk_signal_connect(GTK_OBJECT(otherVideoCLIST),"select_row",
                     GTK_SIGNAL_FUNC(selection_made_other_list),
                     &otherListHead); 
  
  gtk_container_add(GTK_CONTAINER(otherSCROLLEDWINDOW),otherVideoCLIST);
  gtk_widget_show(otherVideoCLIST);
  
  /* append to notebook */
  gtk_notebook_append_page(GTK_NOTEBOOK(notebook), otherVideoVBOX,
									otherLABEL);
  /* finally show the notebook */
  gtk_widget_show(notebook);
  
  /* anonymous troll label button */
  anonymousHBOX=gtk_hbox_new(FALSE,0);
  gtk_box_pack_end(GTK_BOX(allVBOX),anonymousHBOX,FALSE,FALSE,0);
  anonymousBUTTON=gtk_button_new_with_label("mim v1.x by An anonymous troll");
  gtk_box_pack_start(GTK_BOX(anonymousHBOX),anonymousBUTTON,TRUE,TRUE,0);
  gtk_button_set_relief(GTK_BUTTON(anonymousBUTTON),GTK_RELIEF_NONE);
  gtk_widget_set_sensitive(anonymousBUTTON,FALSE);
  gtk_widget_show(anonymousBUTTON);
  gtk_widget_show(anonymousHBOX);
  
  /* initialize the linked lists and read the cached entries */
  
  mpegListHead=NULL;
  mpegListTail=NULL;
  otherListHead=NULL;
  otherListTail=NULL;

  read_cache();
  gtk_widget_show(mainWINDOW);
  
  pthread_create(&sdpListenerThread,NULL,(void *)sdp_listener,NULL);
  
  gdk_threads_enter();
  gtk_main();
  gdk_threads_leave();
  
  return 0;
}





